Aplicaciones/mecanica/urls.py
from django.urls import path,include
from . import views
urlpatterns = [
    path('', views.plantilla),
    path('listadoMarcas/',views.listadoMarcas),
    path('guardarMarca/',views.guardarMarca),
    path('eliminarMarca/<id>',views.eliminarMarca),
    path('editarMarca/<id>',views.editarMarca),
    path('procesarActualizarMarca/',views.procesarActualizarMarca),
    # cliente
    path('listadoClientes/',views.listadoClientes,name='listadoClientes/'),
    path('guardarCliente/',views.guardarCliente,name='guardarCliente/'),
    path('eliminarCliente/<id>',views.eliminarCliente,name='eliminarCliente/'),
    path('editarCliente/<id>',views.editarCliente,name='eliminarCliente/'),
    path('procesarActualizarCliente/',views.procesarActualizarCliente,name='procesarActualizarCliente/'),
    path('listadoMecanico/', views.listadoMecanico, name='listadomecanico/'),
    # vehiculo
    path('listadoVehiculos/',views.listadoVehiculos,name='listadoVehiculos/'),
    path('guardarVehiculo/',views.guardarVehiculo,name='guardarVehiculo/'),
    path('eliminarVehiculo/<id>',views.eliminarVehiculo,name='eliminarVehiculo/'),
    path('editarVehiculo/<id>',views.editarVehiculo,name='eliminarVehiculo/'),
    path('procesarActualizarVehiculo/',views.procesarActualizarVehiculo,name='procesarActualizarVehiculo/'),


    # PRODUCTO
    path('listadoProductos/',views.listadoProductos,name='listadoProductos/'),
    path('guardarProducto/',views.guardarProducto,name='guardarProducto/'),
    path('eliminarProducto/<id>',views.eliminarProducto,name='eliminarProducto/'),
    path('editarProducto/<id>',views.editarProducto,name='eliminarProducto/'),
    path('procesarActualizarProducto/',views.procesarActualizarProducto,name='procesarActualizarProducto/'),

    # Servicios
    path('listadoServicios/',views.listadoServicios, name='listadoServicios/'),
    path('guardarServicios/',views.guardarServicios, name='guardarServicios/'),
    path('eliminarServicios/<id>',views.eliminarServicios, name='eliminarServicios/'),
    path('editarServicios/<id>', views.editarServicios, name='editarServicios'),
    path('procesarActualizacionServicios/', views.procesarActualizacionServicios),

# <<<<<<< HEAD
    path('listadoMecanico/', views.listadoMecanico, name='listadomecanico/'),
    path('guardarMecanico/',views.guardarMecanico, name='guardarMecanico/'),
    path('eliminarMecanico/<id>',views.eliminarMecanico, name='eliminarMecanico'),
    path('editarMecanico/<id>',views.editarMecanico, name='editarMecanico'),
    path('procesarActualizacionMecanico/',views.procesarActualizacionMecanico,),
    path('listadoMarcas/',views.listadoMarcas),

    path('listadoFacturas/',views.listadoFacturas, name='listadoFacturas/'),
    path('guardarFacturas/',views.guardarFacturas, name='guardarFacturas/'),
    path('eliminarFacturas/<id_fac>',views.eliminarFacturas, name='eliminarFacturas'),
    path('editarFacturas/<id_fac>',views.editarFacturas, name='editarFacturas'),
    path('procesarActualizacionFactura/',views.procesarActualizacionFactura),
    path('listadoFacturas/',views.listadoFacturas),

    path('listadoServicios/',views.listadoServicios, name='listadoServicios/'),
    path('guardarServicios/',views.guardarServicios, name='guardarServicios/'),
    path('eliminarServicios/<id>',views.eliminarServicios, name='eliminarServicios'),
    ]

Aplicaciones/mecanica/models.py
from django.db import models

# Create your models here.
class Marca(models.Model):
    id = models.AutoField(primary_key=True)
    nombre_marca = models.CharField(max_length=100)
    logo =models.FileField(upload_to='marca',null=True,blank=True)

    def __str__(self):
        return self.nombre_marca
class Cliente(models.Model):
    id = models.AutoField(primary_key=True)
    nombre = models.CharField(max_length=150)
    direccion = models.TextField()
    telefono = models.CharField(max_length=15)
    correo = models.EmailField()
    cedula = models.CharField(max_length=15, unique=True)
    foto=models.FileField(upload_to='cliente', null=True, blank=True)

    def __str__(self):
        return self.nombre


class Producto(models.Model):
    id = models.AutoField(primary_key=True)
    nombre = models.CharField(max_length=100)
    descripcion = models.TextField()
    cantidad_stock = models.PositiveIntegerField(default=0)
    fecha_entrada = models.DateField(auto_now_add=True)
    proveedor = models.CharField(max_length=100)

    def __str__(self):
        return self.nombre

class Servicios(models.Model):
    id = models.AutoField(primary_key=True)
    descripcion = models.CharField(max_length=150)
    costo = models.DecimalField(max_digits=10, decimal_places=2)
    nota = models.CharField(max_length=150)
    estado = models.CharField(max_length=50)  # Puedes ajustar la longitud según tus necesidades

    # Relación muchos a muchos con Producto
    productos = models.ManyToManyField(Producto, related_name='servicios_relacionados')

    def __str__(self):
        return f"{self.descripcion} - {self.costo} - {self.nota}"
class Mecanico(models.Model):
    id=models.AutoField(primary_key=True)
    nombre=models.CharField(max_length=150)
    especialidad=models.CharField(max_length=150)
    telefono=models.CharField(max_length=10)
    correo=models.EmailField()
    foto=models.FileField(upload_to='mecanico', null=True, blank=True)

    def _str_(self):
        fila="{0}: {1} {2} - {3}"

class Vehiculo(models.Model):
    id = models.AutoField(primary_key=True)
    modelo = models.CharField(max_length=50)
    placa = models.CharField(max_length=8, unique=True)
    kilometraje= models.TextField()
    estado = models.CharField(max_length=150)
    fecha_entrada = models.DateField(auto_now_add=True, null=True,blank=True)
    total = models.DecimalField(max_digits=10, decimal_places=2)
    marca = models.ForeignKey(Marca,null=True,blank=True,on_delete=models.PROTECT)
    cliente = models.ForeignKey(Cliente,null=True,blank=True,on_delete=models.PROTECT)
    mecanico = models.ForeignKey(Mecanico,null=True,blank=True,on_delete=models.PROTECT)
    # Relación muchos a muchos con Producto
    servicios = models.ManyToManyField(Servicios, related_name='servicios_relacionados')
    def __str__(self):
        return self.modelo



class Facturacion(models.Model):
    id_fac = models.AutoField(primary_key=True)
    fecha_emision = models.DateField(auto_now_add=True)
    subtotal = models.DecimalField(max_digits=10, decimal_places=2)
    total = models.DecimalField(max_digits=10, decimal_places=2)

    def __str__(self):
        fila = "{0}: Subtotal {1}, Total {2}"
        return fila.format(self.fecha_emision, self.subtotal, self.total)

Aplicaciones/mecanica/views.py
# <<<<<<< HEAD
from django.shortcuts import render, redirect, get_object_or_404
from .models import Mecanico, Facturacion, Servicios
from django.contrib import messages
# =======
from django.shortcuts import render
from .models import Marca
from .models import Vehiculo
from .models import Cliente
from .models import Producto
from decimal import Decimal
from django.db import IntegrityError
# >>>>>>> fecf9de (nueva plantilla)
# Create your views here.
def plantilla(request):
    return render(request,'cuerpo.html')
# =======
def listadoMarcas(request):
    marcaBdd=Marca.objects.all()
    return render(request,"marca/marca.html",{'marcas':marcaBdd})
def guardarMarca(request):
    nombre_marca= request.POST["nombre_marca"]
    logo=request.FILES.get("logo")
    nuevoMarcae=Marca.objects.create(nombre_marca=nombre_marca,
    logo=logo)
    messages.success(request, 'Marca guardada exitosamente')
    return redirect('/listadoMarcas/')
def eliminarMarca(request,id):
    marcaEliminar = Marca.objects.get(id=id)
    marcaEliminar.delete()
    messages.success(request, 'Marca eliminada exitosamente')
    return redirect('/listadoMarcas/')
def editarMarca(request,id):
    marcaEditar=Marca.objects.get(id=id)
    return render(request,'marca/editarMarca.html',{'marca':marcaEditar})
def procesarActualizarMarca(request):
    id=request.POST["id"]
    nombre_marca= request.POST["nombre_marca"]
    logo=request.FILES.get("logo")
    #Insertando datos mediante el ORM de DJANGO
    marcaEditar=Marca.objects.get(id=id)
    # Verificar si se proporcionó una nueva fotografía
    if logo:
        marcaEditar.logo = logo
    marcaEditar.nombre_marca=nombre_marca
    marcaEditar.save()
    messages.success(request,
      'Cliente ACTUALIZADO Exitosamente')
    return redirect('/listadoMarcas/')
    # cliente
def listadoClientes(request):
    clienteBdd=Cliente.objects.all()
    return render(request,"cliente/cliente.html",{'clientes':clienteBdd})
def guardarCliente(request):
    if request.method == 'POST':
        # Obtenemos cada campo del formulario
        nombre = request.POST.get("nombre")
        direccion = request.POST.get("direccion")
        telefono = request.POST.get("telefono")
        correo = request.POST.get("correo")
        cedula = request.POST.get("cedula")
        foto = request.FILES.get("foto")

        try:
            # Creamos un nuevo objeto Cliente
            nuevoCliente = Cliente.objects.create(
                nombre=nombre,
                direccion=direccion,
                telefono=telefono,
                correo=correo,
                cedula=cedula,
                foto=foto
            )
            messages.success(request, 'Cliente guardado exitosamente')
            return redirect('/listadoClientes/')
        except IntegrityError:
            # Manejar la excepción de violación de restricción única
            messages.error(request, 'Error: Ya existe un cliente con esa cédula.')
    else:
        # Si es una solicitud GET, simplemente mostramos el formulario vacío
        return render(request, 'cuerpo.html', {})

    return render(request, 'cuerpo.html', {})
def eliminarCliente(request,id):
    clienteEliminar = Cliente.objects.get(id=id)
    clienteEliminar.delete()
    messages.warning(request, 'Cliente eliminada exitosamente')
    return redirect('/listadoClientes/')
def editarCliente(request,id):
    clienteEditar=Cliente.objects.get(id=id)
    return render(request,'cliente/editarCliente.html',{'cliente':clienteEditar})
def procesarActualizarCliente(request):
    if request.method == 'POST':
        # Obtenemos cada campo del formulario
        id=request.POST["id"]
        nombre = request.POST.get("nombre")
        direccion = request.POST.get("direccion")
        telefono = request.POST.get("telefono")
        correo = request.POST.get("correo")
        cedula = request.POST.get("cedula")
        foto = request.FILES.get("foto")
        try:
            # Creamos un nuevo objeto Cliente
            clienteEditar=Cliente.objects.get(id=id)
            # Verificar si se proporcionó una nueva fotografía
            if foto:
                clienteEditar.foto = foto
            clienteEditar.nombre=nombre
            clienteEditar.direccion=direccion
            clienteEditar.correo=correo
            clienteEditar.cedula=cedula
            clienteEditar.telefono=telefono
            clienteEditar.save()
            messages.success(request, 'Cliente actualizado exitosamente')
            return redirect('/listadoClientes/')
        except IntegrityError:
            # Manejar la excepción de violación de restricción única
            messages.error(request, 'Error: Ya existe un cliente con esa cédula.')
    else:
        # Si es una solicitud GET, simplemente mostramos el formulario vacío
        return render(request, 'cuerpo.html', {})
    return render(request, 'cuerpo.html', {})
    #Insertando datos mediante el ORM de DJANGO

# Vehiculos
def listadoVehiculos(request):
    vehiculoBdd=Vehiculo.objects.all()
    marcaBdd=Marca.objects.all()
    clienteBdd=Cliente.objects.all()
    mecanicoBdd=Mecanico.objects.all()
    servicioBdd=Servicios.objects.all()
    return render(request,"vehiculo/vehiculo.html",{'vehiculos':vehiculoBdd,'marcas':marcaBdd,
    'clientes':clienteBdd,'mecanicos':mecanicoBdd,
    'servicios':servicioBdd})

def guardarVehiculo(request):
    if request.method == 'POST':
        # Obtenemos cada campo del formulario
        modelo = request.POST.get("modelo")
        placa = request.POST.get("placa")
        kilometraje = request.POST.get("kilometraje")
        estado = request.POST.get("estado")
        total = request.POST.get("totalCosto")
        cliente = request.POST["cliente"]

        # transformo a objeto
        clienteSeleccionado = Cliente.objects.get(id=cliente)
        marca = request.POST["marca"]
        # transformo a objeto
        marcaSeleccionado = Marca.objects.get(id=marca)
        mecanico = request.POST["mecanico"]
        # transformo a objeto
        mecanicoSeleccionado = Mecanico.objects.get(id=mecanico)

        # Ahora obtenemos servicios_seleccionados del formulario
        servicios_seleccionados = [int(servicio_id) for servicio_id in request.POST.get("productos_seleccionados", "").split(",") if servicio_id]

        try:
            # Creamos un nuevo objeto Vehiculo
            nuevoVehiculo = Vehiculo.objects.create(
                modelo=modelo,
                placa=placa,
                kilometraje=kilometraje,
                estado=estado,
                total=total,
                cliente=clienteSeleccionado,
                marca=marcaSeleccionado,
                mecanico=mecanicoSeleccionado
            )

            # Asociamos los servicios seleccionados al nuevo vehículo
            nuevoVehiculo.servicios.set(servicios_seleccionados)

            messages.success(request, 'Vehiculo guardado exitosamente')
            return redirect('/listadoVehiculos/')
        except IntegrityError:
            # Manejar la excepción de violación de restricción única
            messages.error(request, 'Error: Ya existe un vehiculo con esa placa.')
            return redirect('/listadoVehiculos/')
    else:
        # Si es una solicitud GET, simplemente mostramos el formulario vacío
        return render(request, 'vehiculo/vehiculo.html', {})

    return render(request, 'cuerpo.html', {})
def eliminarVehiculo(request,id):
    vehiculoEliminar = Vehiculo.objects.get(id=id)
    vehiculoEliminar.delete()
    messages.warning(request, 'Vehiculo eliminada exitosamente')
    return redirect('/listadoVehiculos/')
def editarVehiculo(request,id):
    vehiculoEditar=Vehiculo.objects.get(id=id)
    marcaBdd=Marca.objects.all()
    clienteBdd=Cliente.objects.all()
    return render(request,'vehiculo/editarVehiculo.html',{'vehiculo':vehiculoEditar,'marcas':marcaBdd,'clientes':clienteBdd})
def procesarActualizarVehiculo(request):

    if request.method == 'POST':
        # Obtenemos cada campo del formulario
        id=request.POST["id"]
        modelo = request.POST.get("modelo")
        placa = request.POST.get("placa")
        kilometraje = request.POST.get("kilometraje")
        estado = request.POST.get("estado")
        cliente= request.POST["cliente"]
        # trafomo a onjeto
        clienteSeleccionado=Cliente.objects.get(id=cliente)
        marca= request.POST["marca"]
        # trafomo a onjeto
        marcaSeleccionado=Marca.objects.get(id=marca)
        try:
            # Creamos un nuevo objeto Cliente
            vehiculoEditar=Vehiculo.objects.get(id=id)
            # Verificar si se proporcionó una nueva fotografía
            vehiculoEditar.modelo=modelo
            vehiculoEditar.placa=placa
            vehiculoEditar.kilometraje=kilometraje
            vehiculoEditar.estado=estado
            vehiculoEditar.cliente=clienteSeleccionado
            vehiculoEditar.marca=marcaSeleccionado
            vehiculoEditar.save()
            messages.success(request, 'Vehiculo actualizado exitosamente')
            return redirect('/listadoVehiculos/')
        except IntegrityError:
            # Manejar la excepción de violación de restricción única
            messages.error(request, 'Error: Ya existe un vehiculo con esa placa.')
            return redirect('/listadoVehiculos/')
    else:
        # Si es una solicitud GET, simplemente mostramos el formulario vacío
        return render(request, 'cuerpo.html', {})

    return render(request, 'cuerpo.html', {})
    #Insertando datos mediante el ORM de DJANGO
# PRODUCTOS
def listadoProductos(request):
    productoBdd=Producto.objects.all()
    return render(request,"producto/producto.html",{'productos':productoBdd})
def guardarProducto(request):
    if request.method == 'POST':
        # Obtenemos cada campo del formulario
        nombre = request.POST.get("nombre")
        cantidad_stock = request.POST.get("cantidad_stock")
        proveedor = request.POST.get("proveedor")

Aplicaciones/mecanica/templates/producto/editarProducto.html
{% extends "plantilla.html"%}


{% block contenido%}
{% load static %}

<div class="main-container">
  <div class="pd-ltr-20">
    <div class="card-box pd-20 height-100-p mb-30">
      <div class="row align-items-center">
        <div class="col-md-4">
          <h4 class="font-20 weight-500 mb-10 text-capitalize">
            Editar Marca {{marca.nombre_marca}} <div class="weight-60 font-3 text-blue">
          </h4>
        </div>
        <div class="col-md-8">

        </div>
      </div>
      <form class="" action="/procesarActualizarProducto/" method="post" enctype="multipart/form-data" id="frm_marca">
        {% csrf_token %}
        <input type="hidden" name="id"  value="{{producto.id}}">

          <div class="row">
            <div class="col-md-6">
              <label for="id_nombre">Nombre:</label>
              <input type="text" id="nombre" name="nombre" maxlength="100" required class="form-control" value="{{producto.nombre}}">
            </div>
            <div class="col-md-6">
              <label for="id_cantidad_stock">Cantidad en stock:</label>
              <input type="number" id="cantidad_stock" name="cantidad_stock" required class="form-control" value="{{ producto.cantidad_stock|floatformat:0 }}">
            </div>
          </div>
          <div class="row">
            <div class="col-md-12">
              <label for="id_proveedor">Proveedor:</label>
              <input type="text" id="proveedor" name="proveedor" maxlength="100" required class="form-control" value="{{producto.proveedor}}">
            </div>
            <div class="col-md-12">
              <label for="id_descripcion">Descripción:</label>
              <textarea id="descripcion" name="descripcion" required class="form-control" >{{producto.descripcion}}</textarea>
            </div>
          </div>
          <div class="col-md-12 mt-3">
            <center>
              <button type="submit" class="btn btn-primary"><i class="bi bi-floppy"></i>&nbsp; Guardar Marca</button>
              &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
              <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar</button>
            </center>
          </div>
        </form>
    </div>

    </div>
  </div>




{% endblock %}

Aplicaciones/mecanica/templates/producto/producto.html
{% extends "plantilla.html"%}
{% block contenido%}
{% load static %}
<div class="main-container">
  <div class="pd-ltr-20">
    <div class="card-box pd-20 height-100-p mb-30">
      <div class="row align-items-center">
        <div class="col-md-4">
          <h4 class="font-20 weight-500 mb-10 text-capitalize">
            LISTADO PRODUCTOS <div class="weight-600 font-30 text-blue">
              <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal">
                NUEVO PRODUCTO
              </button></div>
          </h4>
        </div>
        <div class="col-md-8">
        </div>
      </div>
    </div>
    <table class="table" cellspacing="0" width="100%" id="mitab">
    <thead>
        <tr>
            <td>ID</td>
            <td>NOMBRE</td>
            <td>DESCRIPCION</td>
            <td>STOCK</td>
            <td>PROVEEDOR </td>
            <td>FECHA ENTRADA</td>
            <td>ACCIONES</td>
        </tr>
    </thead>
    <tbody>
        {% for producto in productos %}
        <tr>
            <td>{{producto.id}}</td>
            <td>{{producto.nombre}}</td>
            <td>{{producto.descripcion}}</td>
            <td>{{producto.cantidad_stock}}</td>
            <td>{{producto.proveedor}}</td>
            <td>{{producto.fecha_entrada}}</td>
            <td>
                <a href="/editarProducto/{{producto.id}}" class="btn btn-warning">EDITAR</a>
                <a href="javascript:void(0)"
                    onclick="eliminar('/eliminarProducto/{{producto.id}}');"
                    class="btn btn-danger">
                    Eliminar
                </a>
            </td>
        </tr>
        {% endfor%}
    </tbody>
</table>
<script type="text/javascript" src="https://cdn.datatables.net/plug-ins/1.11.5/i18n/Spanish.json"></script>
<script type="text/javascript">
    $(document).ready(function() {
        $('#mitab').DataTable({
            dom: 'Bfrtip',
            buttons: [
                {
                    extend: 'pdfHtml5',
                    messageTop: 'PDF created by PDFMake with Buttons for DataTables.'
                },
                'print',
                'csv'
            ],
            "language": {
                "url": "https://cdn.datatables.net/plug-ins/1.11.5/i18n/Spanish.json"
            }
            // Puedes agregar más opciones según tus requisitos
        });
    });
</script>
    </div>
  </div>
  <!-- Modal -->
  <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content ">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          <form class="" action="/guardarProducto/" method="post" enctype="multipart/form-data" id="frm_marca">
            {% csrf_token %}
            <div class="row">
              <div class="col-md-6">
                <label for="id_nombre">Nombre:</label>
                <input type="text" id="nombre" name="nombre" maxlength="100" required class="form-control" >
              </div>
              <div class="col-md-6">
                <label for="id_cantidad_stock">Cantidad en stock:</label>
                <input type="number" id="cantidad_stock" name="cantidad_stock" value="0" required class="form-control" >
              </div>
            </div>
            <div class="row">
              <div class="col-md-12">
                <label for="id_proveedor">Proveedor:</label>
                <input type="text" id="proveedor" name="proveedor" maxlength="100" required class="form-control" >
              </div>
              <div class="col-md-12">
                <label for="id_descripcion">Descripción:</label>
                <textarea id="descripcion" name="descripcion" required class="form-control" ></textarea>
              </div>
            </div>
            <div class="col-md-12 mt-3">
              <center>
                <button type="submit" class="btn btn-primary"><i class="bi bi-floppy"></i>&nbsp; Guardar Marca</button>
                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar</button>
              </center>
            </div>
          </form>
        </div>
        <div class="modal-footer">
        </div>
      </div>
    </div>
  </div>
{% endblock %}